# Copyright 2016 Red Hat, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#
# Refer to the README and COPYING files for full details of the license

%define        __spec_install_post %{nil}
%define          debug_package %{nil}
%define        __os_install_post %{_dbpath}/brp-compress

# define the python package prefix based on distribution version
# this is needed to require a correct python-openvswitch package:
# python-openvswitch or python2-openvswitch for fedora >=25
%if 0%{?fedora} >= 25
%define _py2 python2
%else
%define _py2 python
%endif

Name:           ovirt-provider-ovn
Version:        1.2.14
Release:        1%{?dist}
Summary:        The oVirt external network provider for OVN
License:        GPLv2+
BuildArch:      noarch
URL:            https://gerrit.ovirt.org/#/admin/projects/ovirt-provider-ovn
Source0:        http://resources.ovirt.org/pub/src/%{name}/%{name}-%{version}.tar.gz

Requires: firewalld-filesystem
Requires: kernel >= 3.10.0-512

Requires: openvswitch >= 0:2.7
Requires: openvswitch-ovn-central >= 0:2.7
Requires: openvswitch-ovn-common >= 0:2.7
Requires: %{_py2}-openvswitch >= 0:2.7

Conflicts: openvswitch = 1:2.6.1
Conflicts: openvswitch-ovn-central = 1:2.6.1
Conflicts: openvswitch-ovn-common = 1:2.6.1
Conflicts: %{_py2}-openvswitch = 1:2.6.1

Requires: python-requests
Requires: python-netaddr
Requires: python2-ovsdbapp

BuildRequires: python
BuildRequires: systemd

%prep
%setup -q

%build

%install
%make_install


%description
The oVirt external network provider for OVN allows to integrate oVirt with the
Open vSwitch Open Virtual Network (OVN) solution. OVN is a Software Defined
Networking extension to Open vSwitch. OVN is integrated into oVirt using the
external network API. The oVirt provider for OVN serves as a proxy between
oVirt engine and OVN Northbound DB.

%post
%systemd_post ovirt-provider-ovn.service


%preun
%systemd_preun ovirt-provider-ovn.service


%postun
%systemd_postun_with_restart ovirt-provider-ovn.service


%package driver
Summary: The virtual interface driver for oVirt external network provider for OVN
License: GPLv2+
BuildArch: noarch
Requires: firewalld-filesystem
Requires: kernel >= 3.10.0-512

Requires: openvswitch >= 0:2.7
Requires: openvswitch-ovn-host >= 0:2.7
Requires: openvswitch-ovn-common >= 0:2.7
Requires: %{_py2}-openvswitch  >= 0:2.7

Conflicts: openvswitch = 1:2.6.1
Conflicts: openvswitch-ovn-host = 1:2.6.1
Conflicts: openvswitch-ovn-common = 1:2.6.1
Conflicts: %{_py2}-openvswitch = 1:2.6.1

Requires: vdsm
Requires(post): firewalld-filesystem


%description driver
The virtual interface driver for oVirt external network provider for OVN.
The driver handles the connection of virtual NICs provisioned on oVirt hosts
to OVN.


%files
%config(noreplace) %{_sysconfdir}/ovirt-provider-ovn
%config(noreplace) %{_sysconfdir}/logrotate.d/ovirt-provider-ovn
%{_datadir}/ovirt-provider-ovn
%{_unitdir}/ovirt-provider-ovn.service
%{_prefix}/lib/firewalld/services/ovirt-provider-ovn.xml
%doc /usr/share/doc/ovirt-provider-ovn/README.adoc
%license LICENSE

%files driver
%{_libexecdir}/vdsm/hooks/before_nic_hotplug/*
%{_libexecdir}/vdsm/hooks/before_device_create/*
%{_libexecdir}/vdsm/hooks/after_get_caps/*
%{_libexecdir}/vdsm/hooks/after_vm_destroy/*
%{_libexecdir}/vdsm/vhostuser_permissions_setter
%{_libexecdir}/ovirt-provider-ovn
%{python_sitelib}/vdsm/tool/ovn_config.py*
%{_sysconfdir}/sudoers.d/50_vdsm_hook_ovirt_provider_ovn_hook
%license LICENSE


%changelog
* Thu Sep 20 2018 Sandro Bonazzola <sbonazzo@redhat.com> - 1.2.14-1
- Rebase on upstream 1.2.14

* Fri Apr 27 2018 Sandro Bonazzola <sbonazzo@redhat.com> - 1.2.10-1
- Rebase on upstream 1.2.10

* Fri Mar 23 2018 Sandro Bonazzola <sbonazzo@redhat.com> - 1.2.9-1
- Rebase on upstream 1.2.9

* Tue Jan 23 2018 Sandro Bonazzola <sbonazzo@redhat.com> - 1.0.9-1
- Initial packaging
